2021-07-03  Gavin Smith  <gavinsmith0123@gmail.com>

	6.8
	
	* tp/Texinfo/Convert/HTML.pm: unconditionally reference MathJax
	code if HTML_MATH is 'mathjax' and it is non-split output.

2021-07-03  Gavin Smith  <gavinsmith0123@gmail.com>

	6.8

	* configure.ac, NEWS, util/texi2dvi, util/texi2pdf: versionn
	* tp/Texinfo/Documentlanguages.pm: Regenerate.

2021-07-02  Gavin Smith  <gavinsmith0123@gmail.com>

	* INSTALL: Refer to doc/README.  From Patrice.

2021-07-01  Gavin Smith  <gavinsmith0123@gmail.com>

	* doc/README: tweak instructions

2021-06-30  Gavin Smith  <gavinsmith0123@gmail.com>

	pretest 6.7.92

	* configure.ac, util/texi2dvi, util/texi2pdf: version
	* tp/texi2any.pl: 2021
	* README-hacking: update

2021-06-30  Gavin Smith  <gavinsmith0123@gmail.com>

	Remove old js files.
	
	* js/texinfo-js.in, js/texinfo-js.texi,
	* js/build-aux/eslint.json, js/build-aux/modernizr.json,
	js/build-aux/texinfo.tex: Remove.
	* js/README: remove out-of-date material

2021-06-24  Patrice Dumas  <pertusus@free.fr>

	Remove SVN keyword.

	* util/texi2pdf (version), util/pdftexi2dvi (version): Do not
	use '$Revision$' keyword as this doesn't work with git.

2021-06-22  Per Bothner  <per@bothner.com>

	* js/info.js (Remote_store): Use parent window rather than top window.
	The latter breaks if we're running the info browser in an iframe.

2021-06-20  Gavin Smith  <gavinsmith0123@gmail.com>

	* NEWS: update

2021-06-17  Gavin Smith  <gavinsmith0123@gmail.com>

	* Pod-Simple-Texinfo/pod2texi.pl: Fix some messages.  Report from
	Benno Schulenberg.  Update copyright years.

2021-06-16  Gavin Smith  <gavinsmith0123@gmail.com>

	pretest 6.7.91

	* configure.ac, util/texi2dvi, util/texi2pdf,
	* info/info.c (main), install-info/install-info.c (main):
	version, 2021.

2021-06-08  Gavin Smith  <gavinsmith0123@gmail.com>

	Document @indent @image{}

	* doc/texinfo.texi (Image Syntax): Document that @image commands
	should sometimes be preceded by @indent or @noindent.

2021-05-06  Gavin Smith  <gavinsmith0123@gmail.com>

	Fix afl-fuzz error
	
	* info/info-utils.c (scan_reference_label): Avoid advancing
	pointer if we are already at the end of the buffer, in the case
	of a malformed input file.  Report from Nathaniel Beaver for file
	generated by afl-fuzz.

2021-05-06  Gavin Smith  <gavinsmith0123@gmail.com>

	Fix afl-fuzz error

	* info/info-utils.c (copy_input_to_output): Avoid calling
	copy_converting with negative argument in case of malformed
	input file.  Report from Nathaniel Beaver for file generated
	by afl-fuzz.

2021-05-04  Per Bothner  <per@bothner.com>

	* js/info.js (updater.navigate): Relative movement without node links.
	For example if the current item is a @subsection without a @node,
	requesting the 'next' item can't use the Next link as there is none.
	Instead, use the nesting in the sidebar ToC.

	* js/info.js: Use keydown event handler instead of keyup.
	The former is more standard.

2021-05-02  Patrice Dumas  <pertusus@free.fr>

	* tp/Texinfo/Convert/HTML.pm (_convert_image_command): format
	@image with an <img> tag in preformatted environment.  Report from
	Per Bothner.

2021-05-02  Per Bothner  <per@bothner.com>

	* js/info.js: Fix sidebar-update after selecting non-section link.
	For example index link or @anchor are not sections,
	hence not in the ToC.  To update the sidebar we need to find the
	the sectioning element surrounding the anchor.
	This involves some back-and-forth messaging.

2021-05-02  Vitezslav Crhonek <vcrhonek@redhat.com>

	* contrib/fix-info-dir:  Remove unused variable

2021-05-02  Vitezslav Crhonek <vcrhonek@redhat.com>

	* util/texi2dvi (input_file_name_decode):
	Fix ShellCheck SC1083 warning
	https://github.com/koalaman/shellcheck/wiki/SC1083
	This is only for suppresing the warning, both '{' and '}'
	are supposed to be literals.

2021-05-02  Gavin Smith  <gavinsmith0123@gmail.com>

	Avoid extra newline after @titlefont

	* tp/Texinfo/Convert/Plaintext.pm (_convert) <@titlefont>:
	Remove newline from end of output as a newline following
	@titlefont{...} is now output separately since change on
	2021-04-25.

2021-04-29  Per Bothner  <per@bothner.com>

	* js/info.js (Text_input.keyup): At end hide sidebar if narrow.

	* js/info.js (Sidebar.render): Fix initial rendering.

	* js/info.css: Style hide-sidebar buttom vertically.

2021-04-28  Per Bothner  <per@bothner.com>

	* js/info.js: Change auto-hide of sidebar in narrow windows.
	Now clicking in sidebar in narror window doesn't hide sidebar,
	but click in main page does - however, navigation is supressed.
	Also changed the show/hide-sidebar logic to work using the
	store/action/dispatch framework.

2021-04-27  Per Bothner  <per@bothner.com>

	* js/info.js (config.LOCAL_HTML_PAGE_PATTERN): Handle local links.
	I.e. links like "#foo" on the same page.

	* js/info.js (cache_index_links): Fix thinko alink->link.

2021-04-27  Per Bothner  <per@bothner.com>

	Change how "show/hide sidebar" button is displayed.
	Move it to upper-left and use arrows, to hopefully both
	make it more visible and take less space in hide mode.
	* js/info.js (add_header): Change DOM structure to make this work.
	(hide_sidebar_if_narrow): New function.
	* js/info.css: Styling changes for desired show/hide style.

	Improve determination of whether links are internal or not.
	* js/info.js (config.LOCAL_HTML_PAGE_PATTERN): New regex pattern
	(maybe_pageref_url_p): Use LOCAL_HTML_PAGE_PATTERN.

2021-04-25  Gavin Smith  <gavinsmith0123@gmail.com>

	Avoid suppressing first paragraph indent with an @image.

	* doc/texinfo.tex (\imageindent): New macro.
	(\image): Use it.
	* doc/texinfo-tex-test.texi (Paragraph formatting): New section.

	Inconsistency between Info and TeX reported by Werner Lemberg.

2021-04-25  Gavin Smith  <gavinsmith0123@gmail.com>

	Whitespace after @image

	* tp/Texinfo/Convert/Plaintext.pm (_convert): Output any
	top-level whitespace element.  This allows a blank line
	of whitespace to appear after an @image that is not part
	of a paragraph.

	* tp/t/05paragraph.t (sole_image): New test.

	Report from Werner Lemberg.

2021-04-25  Gavin Smith  <gavinsmith0123@gmail.com>

	* info/nodes.c (get_tags_of_indirect_tags_table):
	Free arrays in case of malformed Info file.
	Report from Vitezslav Crhonek.

2021-04-25  Gavin Smith  <gavinsmith0123@gmail.com>

	* info/nodes.c (get_tags_of_indirect_tags_table):
	Reduce indentation of code.

2021-04-25  Vitezslav Crhonek <vcrhonek@redhat.com>  (tiny change)

	Fix memory leaks.

	* info/nodes.c (get_nodes_of_tags_table):
	info_create_tag returns a pointer to a newly allocated TAG structure.
	Before continuing to the start of the loop it is necessary to free the
	current TAG structure, because the pointer will be overwritten by
	new value in the next iteration of the loop.

2021-04-25  Vitezslav Crhonek <vcrhonek@redhat.com>  (tiny change)

	Fix memory leaks.
	
	* info/makedoc.c (process_one_file):
	The memory is freed for both pointers at the end of the loop.
	But there is one break that leaves the loop without freeing them.
	* info/session.c (info_goto_invocation_node):
	The value of 'default_program_name' is assigned by
	program_name_from_file_name() function.
	Its description says 'Return value should be freed by caller.'
	That was not done in this case.

2021-04-25  Gavin Smith  <gavinsmith0123@gmail.com>

	Fix memory leaks.
	
	* info/m-x.c (describe_command): Always free a variable.
	* info/filesys.c (info_file_find_next_in_path): Do not free a string
	that shouldn't be freed.

	Reports from Vitezslav Crhonek.

2021-04-14  Gavin Smith  <gavinsmith0123@gmail.com>

	* doc/texinfo.tex (\doxeteximage):
	Add an \hbox around \XeTeXpdffile or \XeTeXpicfile to avoid
	over-long line.  Report from Werner Lemberg.

2021-04-08  Gavin Smith  <gavinsmith0123@gmail.com>

	* doc/texinfo.tex (\end): Add % after opening brace to
	prevent spurious space being added to the output.  Report
	from Werner Lemberg for "@end iftex".

2021-03-27  Gavin Smith  <gavinsmith0123@gmail.com>

	* info/t/Init-test.inc (run_ginfo): Increase timeout for
	test from 3 to 5 seconds in an attempt to stop test failures.

2021-03-24  Gavin Smith  <gavinsmith0123@gmail.com>

	* doc/texinfo.texi (Multitable Column Widths): Mention effect
	of inter-column space for @columnfractions.

2021-03-23  Gavin Smith  <gavinsmith0123@gmail.com>

	* doc/texinfo.tex (\indexnofonts): Do not define any of the
	non-English letter glyph commands with a special definition
	that removes a following pair of braces, as these braces are
	not always present in the definitions for e.g. Unicode characters.
	This could lead to an error message within \setpdfdestname where
	\indexnofonts was called.  Report from Werner Lemberg for XeTeX.

2021-03-22  Per Bothner  <per@bothner.com>

	* js/info.js: Add tooltips for show/hide sidebar button.
	(SHOW_SIDEBAR_TOOLTIP, HIDE_SIDEBAR_TOOLTIP): Tooltip text.
	(show_sidebar): Update tooltips on show/hide of sidebar.

	* js/info.js (maybe_pageref_url_p): Recognize "index.html#PAGE".

2021-03-20  Gavin Smith  <gavinsmith0123@gmail.com>

	* doc/texinfo.tex (\multitableparskip, \multitableparindent)
	(\multitablecolspace, \multitablelinespace):
	Try removing these and hardcoding values.  \multitablelinespace
	was not used anyway and a comment referred to a @multitablecolmargin
	sequence which didn't exist.  This should make the code a bit
	easier to understand.
	(\setmultitablespacing): Remove.

2021-03-20  Gavin Smith  <gavinsmith0123@gmail.com>

	* doc/texinfo.tex (\multitable): Fix indendation of code.  Remove
	useless macro \multistrut replacing it with \strut (always set to
	this since October 2004).  Remove comment about space added by
	\multistrut, as no such space was added.  Remove documentation of
	@multitable as this is in the manual.  Remove comment crediting
	original author of macros, recorded here as
	Amy Hendrickson, 8/18/94, 3/6/96
	(\tab): Remove comment from April 1999 saying what used to be
	in the code.
	(\alphaenumerate, \capsenumerate): Remove undocumented aliases.


2021-03-18  Gavin Smith  <gavinsmith0123@gmail.com>

	Narrow @multitable nested within @quotation

	* doc/texinfo.tex (\domultitable): Subtract \leftskip before
	calculating column widths as fraction of \hsize.
	* doc/texinfo-tex-test.texi (@multitable): New section.
	
	Report of excessive width from Werner Lemberg.

2021-03-12  Gavin Smith  <gavinsmith0123@gmail.com>

	Fix NetBSD build

	* tp/Texinfo/XS/parsetexi/api.c,
	* tp/Texinfo/XS/parsetexi/errors.c: Surround calls to gettext
	with #ifdef ENABLE_NLS.

2021-03-12  Gavin Smith  <gavinsmith0123@gmail.com>

	* tp/Texinfo/XS/parsetexi/errors.c (bug): Don't call abort.

2021-03-11  Gavin Smith  <gavinsmith0123@gmail.com>

	* tp/tests/coverage_macro.texi: Add blank lines to isolate
	test result differences for some glyph commands.

2021-03-10  Gavin Smith  <gavinsmith0123@gmail.com>

	* doc/texinfo.texi (@copying): Coalesce copyright years where possible.
	(Reporting Bugs): Refer bugs in Info mode to Emacs developers.

2021-03-05  Patrice Dumas  <pertusus@free.fr>

	* Pod-Simple-Texinfo/pod2texi.pl (pod2texi_help): improve
	help message formatting by removing incorrect dots for options.
	Make easier to translate strings by splitting help message,
	splitting options, avoiding \n in translated messages.
	Report by Benno Schulenberg
	* tp/texi2any.pl (makeinfo_help): add TODO to remember to
	avoid \n in translated strings and split translated options
	messages by option.  To be done when strings change.

2021-03-03  Per Bothner  <per@bothner.com>

	* js/info.js (absolute_url_p): Replace with maybe_pageref_url_p.
	New function checks if URL may be cross-reference to local page.
	Prevents failure on links to images or stuff in sub-directories.
	(config.LOCAL_HTML_PAGE_PATTERN): Patternfor HTML files.

2021-03-02  Gavin Smith  <gavinsmith0123@gmail.com>

	* doc/texinfo.texi (Invoking pod2texi): Remove  reference to
	non-existent webpage.

2021-03-01  Gavin Smith  <gavinsmith0123@gmail.com>

	GNULIB_MDA_FDOPEN=0

	* tp/Texinfo/XS/configure.ac: Set GNULIB_MDA_FDOPEN=0 to
	prevent definition of fdopen in gnulib-provided stdio.h, which
	clashes with Perl header files.  Report by Eli Zaretskii.
	Suggested fix from Bruno Haible.

2021-03-01  Gavin Smith  <gavinsmith0123@gmail.com>

	* tp/Texinfo/XS/parsetexi/api.c (element_to_perl_hash):
	Cast pointer to intptr_t before IV to prevent a compiler warning
	on MinGW.  Suggestion from Eli Zaretskii.

2021-02-28  Gavin Smith  <gavinsmith0123@gmail.com>

	Simplify, update, document infrastructure

	* util/srclist.txt: Remove all gettext lines as this should
	be taken care of by gettextize.
	* util/srclist-txi: Likewise.
	* README-hacking: Explain how to check that files have been updated.
	* INSTALL.generic: Update from gnulib.
	* build-aux/config.rpath: Update from gnulib.
	* autogen.sh: Remove obsolete comment about keeping files in CVS.

2021-02-28  Gavin Smith  <gavinsmith0123@gmail.com>

	Run "autoreconf --verbose --force --install" to update
	files under build-aux.  Don't commit changes to INSTALL or
	build-aux/texinfo.tex.

2021-02-27  Gavin Smith  <gavinsmith0123@gmail.com>

	No raw newline in awk string constant

	* texindex/ti.twjr (usage, version): Avoid multi-line character
	string as it appears not to be supported by awk under AIX 7.1.
	Report by Bruno Haible.

2021-02-27  Gavin Smith  <gavinsmith0123@gmail.com>

	Avoid cleaning generated files

	* tp/Texinfo/XS/Makefile.am (CLEANFILES): Remove .c files that
	are generated from .xs files, as these .c files are distributed
	in the tarball and shouldn't be cleaned.
	(.xs.c): Generate .c files under $(srcdir).

	Report from Bruno Haible.

2021-02-27  Gavin Smith  <gavinsmith0123@gmail.com>

	* tp/Texinfo/Report.pm (gdt): Set and restore LC_ALL rather than
	LC_MESSAGES as the latter doesn't work on MS-Windows.  Report
	from Eli Zaretskii.

2021-02-27  Gavin Smith  <gavinsmith0123@gmail.com>

	* texindex/Makefile.am (bin_SCRIPTS): Remove dist_ prefix
	from variable to prevent distribution of the generated texindex
	wrapper script.  Report by Bruno Haible.

2021-02-27  Eli Zaretskii  <eliz@gnu.org>

	* info/session.c (read, _read): #undef before redefining, to avoid
	compilation warning due to Gnulib's unistd.h redefining them.

2021-02-24  Per Bothner  <per@bothner.com>

	* js/info.js: Add button to show/hide sidebar.  Other polishing.
	(Sidebar): Create show/hide button.
	(on_click): Handle clicks on show/hide button.
	Also automatically hide sidebar on click when narrow.
	(Sidebar): Copy _href property when copying ToC.
	* js/info.css: Various adjustments and tricks to make it work.

2021-02-23  Patrice Dumas  <pertusus@free.fr>

	* tp/Texinfo/Common.pm (%default_customization_values),
	(%default_parser_customization_values),
	(%default_structure_customization_values),
	* tp/Texinfo/XS/parsetexi/Parsetexi.pm (%parser_default_configuration),
	(parser),
	* tp/Texinfo/ParserNonXS.pm (%parser_default_configuration),
	* tp/texi2any.pl:
	split %default_customization_values in two, as
	%default_parser_customization_values and
	%default_structure_customization_values differentiating
	parser options and options for Texinfo::Structuring.
	* tp/Texinfo/Structuring.pm (_complete_check_menus_directions),
	(complete_node_tree_with_menus, nodes_tree),
	* tp/t/test_utils.pl (test), tp/texi2any.pl: rename
	_complete_check_menus_directions() as complete_node_tree_with_menus(),
	call _check_referenced_nodes in that function and do not call
	_complete_check_menus_directions in nodes_tree.
	Call Texinfo::Structuring::set_menus_node_directions() and
	Texinfo::Structuring::complete_node_tree_with_menus() in
	texi2any.pl only if 'FORMAT_MENU' is set to 'menu'.
	* tp/texi2any.pl: call $converter_class->converter_defaults()
	with $cmdline_options argument to pass TEXI2HTML customization
	variable for HTML output.

2021-02-23  Patrice Dumas  <pertusus@free.fr>

	* tp/texi2any.pl: use a special value if 'FORMAT_MENU' is set on
	the command line that is replaced by the output format default
	when the output format is known if the output format default is
	not nomenu, or set to 'menu'.

2021-02-23  Gavin Smith  <gavinsmith0123@gmail.com>

	pretest 6.7.90

	* configure.ac, util/texi2dvi, util/texi2pdf: Version.
	* info/info.c (main), install-info/install-info.c (main): 2021
	* README-hacking: Edit release instructions.

	* info/dir.c (dir_entry_of_infodir): Do not call
	info_check_compressed with a null argument.

2021-02-22  Patrice Dumas  <pertusus@free.fr>

	Remove unused code.

	* tp/Texinfo/XS/parsetexi/Parsetexi.pm (%tree_informations)

2021-02-22  Patrice Dumas  <pertusus@free.fr>

	* tp/Texinfo/Structuring.pm (set_menus_node_directions)
	(nodes_tree, _section_direction_associated_node), 
	(_complete_check_menus_directions): separate
	set_menus_node_directions() and _complete_check_menus_directions()
	from nodes_tree() to distinguish better code related to menus
	and not related to menus.  Add _section_direction_associated_node()
	as a small helper function from node_tree too to be able to reuse 
	the code.
	* tp/t/test_utils.pl, tp/texi2any.pl: call
	set_menus_node_directions.
	* tp/Texinfo/Structuring.pm (nodes_tree): set Top node next
	using the sectioning structure first.  Avoid resetting node directions
	based on Top node first menu entry the direction was already set.

2021-02-21  Patrice Dumas  <pertusus@free.fr>

	* tp/Texinfo/Convert/HTML.pm (nodes_tree): use first non Top node
	for Top node next if there is no menu information.

2021-02-21  Patrice Dumas  <pertusus@free.fr>

	use first section in file direction for footer if split at section or
	chapter

	* tp/Texinfo/Convert/HTML.pm, tp/init/book.pm: add 
	CHAPTER_FOOTER_BUTTONS to be able to specify different 
	customization for footer and header when split at chapter.
	(_translate_names, %BUTTONS_*): add FirstInFile* directions.
	(_default_format_element_footer)
	(_default_panel_button_dynamic_direction)
	(_default_panel_button_dynamic_direction_section_footer)
	(_set_variables_texi2html):
	reenable footer when there are more than one element in a file
	and use FirstInFile* directions for section and chapter footer 
	formatting.
	(_default_panel_button_dynamic_direction_footer)
	(_default_panel_button_dynamic_direction_node_footer): rename
	_default_panel_button_dynamic_direction_footer() as
	_default_panel_button_dynamic_direction_node_footer().
	Report from Per Bothner.

2021-02-21  Gavin Smith  <gavinsmith0123@gmail.com>

	* tp/Texinfo/Structuring.pm (nodes_tree):
	Only call _check_referenced_nodes if FORMAT_MENU is not
	"sectiontoc".  From Patrice.

2021-02-21  Patrice Dumas  <pertusus@free.fr>

	* tp/Texinfo/Structuring.pm (_check_referenced_nodes):
	consider a node to be referenced if it is a target of a
	@*ref command.  Report by Gavin.

2021-02-20  Patrice Dumas  <pertusus@free.fr>

	* tp/Texinfo/Structuring.pm (elements_file_directions):
	add FirstInFile* directions for every element.

2021-02-20  Gavin Smith  <gavinsmith0123@gmail.com>

	* tp/Texinfo/Structuring.pm (_check_referenced_nodes):
	New function to centralize code for checking referenced nodes.
	(nodes_tree): Call it.

2021-02-20  Gavin Smith  <gavinsmith0123@gmail.com>

	No footer for several nodes in a file.

	* tp/Texinfo/Convert/HTML.pm (_default_format_element_footer):
	Do not output the element footer if there is more than one node
	in the output file, using the 'elements_in_file_count' hash.

	These changes lead to a few changes as to whether a rule
	is output at the end of a file but the output appeared
	acceptable in the cases I checked.

	Per Bothner reported that the footer would
	be relative to the last node output in the file for
	--split=section, while it would make more sense to have this
	relative to the first node output in the file.  As this is
	not possible to do just now, just omit it.

2021-02-20  Gavin Smith  <gavinsmith0123@gmail.com>

	Fix display of _ in section name.

	* doc/texinfo.tex (\setupdatafile): Read aux file giving
	_ | < and > catcode "active".

	* doc/texinfo-tex-test.texi (~[]"_|<>$#&%+\) Add a test
	of a cross-reference.
	
	Werner Lemberg reported that an underscore in a section title
	would be printed as a dot accent when using
	"@xrefautomaticsectiontitle on".


2021-02-20  Gavin Smith  <gavinsmith0123@gmail.com>

	* doc/texinfo-tex-test.texi (~[]"_|<>$#&%+\) Add example.

2021-02-20  Gavin Smith  <gavinsmith0123@gmail.com>

	* README-hacking: Add advice on using git.

2021-02-20  Gavin Smith  <gavinsmith0123@gmail.com>

	* doc/texinfo.tex (\refx): Remove useless second argument
	which is nearly always empty.

2021-02-20  Patrice Dumas  <pertusus@free.fr>

	* tp/Texinfo/Convert/HTML.pm (_convert_heading_command):
	add a div for sections without nodes.
	(_default_format_element_footer, _default_format_end_file):
	call close_registered_sections_level() in
	_default_format_element_footer() and not in
	_default_format_end_file().
	* tp/t/init/t2h_singular.init (singular_format_footer):
	call close_registered_sections_level().

2021-02-18  Gavin Smith  <gavinsmith0123@gmail.com>

	Fix compiler warnings.
	
	* tp/Texinfo/XS/XSParagraph.xs (xspara_new): Remove code
	setting an unused variable.  It appears that we are not
	blessing the return value into a class after all.
	* tp/Texinfo/XS/parsetexi/handle_commands.c (handle_line_command):
	Parentheses around assignment in conditional.
	* tp/Texinfo/XS/parsetexi/input.c (text_buffer_iconv): Handle
	KOI8 cases in switch statement.
	* tp/Texinfo/XS/parsetexi/macro.c (parse_macro_command_line):
	Remove unused label.

	Report from Per Bothner.

2021-02-18  Gavin Smith  <gavinsmith0123@gmail.com>

	Reform parsetexi header files

	* tp/Texinfo/XS/parsetexi: Make header files include the other
	headers that they need.
	* tp/Texinfo/XS/parsetexi/command_data.awk,
	* tp/Texinfo/XS/parsetexi/element_types.awk: Output include guards
	in generated headers.
	* tp/Texinfo/XS/parsetexi/parser.c,
	* tp/Texinfo/XS/parsetexi/errors.c: (bug, fatal): Move to errors.c.

2021-02-18  Gavin Smith  <gavinsmith0123@gmail.com>

	* tp/Texinfo/Convert/HTML.pm (_default_format_begin_file):
	Add viewport declaration as was already output for node
	redirection pages.  Report from Per Bothner.

2021-02-18  Gavin Smith  <gavinsmith0123@gmail.com>

	* tp/Texinfo/XS/parsetexi: Add include guards to all header files.

2021-02-17  Per Bothner  <per@bothner.com>

	* js/info.js (scan_toc): Change to how sidebar links are matched.
	This fixes updating the sidebar when using a http/https URL.

2021-02-16  Per Bothner  <per@bothner.com>

	* js/info.js: Fix [Contents] link by creating a fresh page-node for
	the ToC.  This is done by cloning the ToC from the index.html.
	Cloning is needed because the same table is used for the Sidebar.

2021-02-16  Gavin Smith  <gavinsmith0123@gmail.com>

	srclist-txi fixes

	* contrib/gdoc: Remove file.  This saves us the trouble of
	working out if/how we should synchronize it with upstream.
	* util/srclist-txi, util/srclist.txt: Remove references to gsasl.

2021-02-16  Gavin Smith  <gavinsmith0123@gmail.com>

	* doc/fdl.texi: Update to latest (URL change).

2021-02-16  Gavin Smith  <gavinsmith0123@gmail.com>

	* README-hacking: Revise release instructions.

2021-02-16  Gavin Smith  <gavinsmith0123@gmail.com>

	Fix for make po-check

	* po/POTFILES.in: Update
	* Makefile.in (po-check): check for parsetexi function calls

2021-02-16  Gavin Smith  <gavinsmith0123@gmail.com>

	Fix for make po-check

	* tp/t/html_tests.t (example_class): Change test to avoid false
	positive with "make po-check".

2021-02-16  Gavin Smith  <gavinsmith0123@gmail.com>

	Fix for make ccheck

	* doc/refcard/txirefcard.tex: Update to 6.8, 2021.  Remove
	@setfilename line from mandatory file beginning.  Add @displaymath.
	* doc/texinfo.texi (small): Add index entries for @smalldisplay
	and @smallindentedblock.

2021-02-16  Gavin Smith  <gavinsmith0123@gmail.com>

	Pre-release fixes

	* configure.ac: Add dist-xz option.  Change TEXINFO_DTD_VERSION to
	6.8.
	* util/txicmdlist, util/txicustomvars: require Texinfo::ModulePath
	so that Locale::Messages can be found from Texinfo::Common.
	* tp/Texinfo/Common.pm: Make @variable_string_settables accessible
	outside of file.
	* doc/refcard/txivarcheck, util/txicustomvars:
	Fix to account for changes in manual and in Texinfo::Common.

2021-02-16  Gavin Smith  <gavinsmith0123@gmail.com>

	* tp/tests/run_parser_all.sh (check_latex2html_and_tex4ht):
	Do not use 'continue' inside a function inside a loop.  Report
	from Vitezslav Crhon.

2021-02-15  Gavin Smith  <gavinsmith0123@gmail.com>

	* tp/Texinfo/Convert/HTML.pm (_convert_element_type):
	Always call close_registered_sections_level to close <div>
	element rather than adding a '</div>' string, as it's possible
	that the <div> was never opened.

2021-02-14  Per Bothner  <per@bothner.com>

	* js/info.css: Adjustments to consistent margin/padding for index and other pages.

2021-02-14  Gavin Smith  <gavinsmith0123@gmail.com>

	* tp/Texinfo/Convert/HTML.pm (_convert_heading_command):
	Only output a <div> for a @node with an associated section.
	Otherwise, output a <span> as an anchor.

2021-02-14  Gavin Smith  <gavinsmith0123@gmail.com>

	* tp/tests/run_parser_all.sh: Print stderr for test error.
	* TODO: Remove item.

2021-02-14  Gavin Smith  <gavinsmith0123@gmail.com>

	* tp/maintain/regenerate_cmd_tests.sh: Remove code that
	was supposed to print diffs (ineffective since 2018-09-01).

2021-02-14  Gavin Smith  <gavinsmith0123@gmail.com>

	* tp/tests/run_parser_all.sh: Print diffs for test failure.

2021-02-14  Patrice Dumas  <pertusus@free.fr>

	* Texinfo/Convert/HTML.pm (_contents_inline_element):
	Put inline contents elements in a <div>.  Report from 
	Per Bothner.

2021-02-14  Patrice Dumas  <pertusus@free.fr>

	* Texinfo/Convert/HTML.pm (%default_formatting_references, 
	converter_initialize, _default_*), init/book.pm, 
	init/chm.pm, init/html32.pm, t/init/mini_ker_t2h.init, 
	t/init/t2h_singular.init: use format_ in formatting functions 
	strings and in formatting function names, to make clearer
	that the references called through the converter with format_
	in the key point to the same functions.  Report from Gavin.

2021-02-13  Patrice Dumas  <pertusus@free.fr>

	* tp/init/book.pm (book_convert_heading_command): update with
	changes in HTML main converter.

2021-02-13  Per Bothner <per@bothner.com>

	Use the sectionning tree structure in HTML output

	* tp/Texinfo/Convert/HTML.pm (register_opened_section_level,
	close_registered_sections_level, _convert_heading_command,
	_convert_element_type, _default_end_file): use <div> for
	elements and keep the sectioning tree structure.

2021-02-10  Gavin Smith  <gavinsmith0123@gmail.com>

	Do not call pclose on non-pipe.

	* install-info/install-info.c (readfile): Only
	call pclose if compression_program is set.  Suggestion from
	Hans-Bernhard Bröker.  Remove an incomprehensible comment.
	(open_possibly_compressed_file):  Revise main comment for function.
	Only fseek back to start of stream if not reading from a pipe.
	
	Barath Aron reported that install-info hung on Threos OS.

2021-02-09  gettextize  <bug-gnu-gettext@gnu.org>

	* gnulib/m4/gettext.m4: Upgrade to gettext-0.21.
	* gnulib/m4/iconv.m4: Upgrade to gettext-0.21.
	* gnulib/m4/intlmacosx.m4: Upgrade to gettext-0.21.
	* gnulib/m4/lib-link.m4: Upgrade to gettext-0.21.
	* gnulib/m4/nls.m4: Upgrade to gettext-0.21.
	* gnulib/m4/po.m4: Upgrade to gettext-0.21.
	* gnulib/m4/progtest.m4: Upgrade to gettext-0.21.
	* configure.ac (AM_GNU_GETTEXT_VERSION): Bump to 0.21.

2021-02-09  Gavin Smith  <gavinsmith0123@gmail.com>

	Wrap or remove calls to abort in XS parser

	* tp/Texinfo/XS/parsetexi/parser.c (bug, fatal): New functions.
	* tp/Texinfo/XS/parsetexi: Use them throughout instead of calling
	abort, in order to give informative error messages.
	* tp/Texinfo/XS/parsetexi/end_line.c (end_line):
	Add code to deal with no description in menu entry.
	* tp/Texinfo/XS/parsetexi/macro.c (parse_macro_command_line):
	Do not abort on missing backslash in macro body.

2021-02-03  Gavin Smith  <gavinsmith0123@gmail.com>

	Fix argument counting for nested @footnote.
	
	* tp/Texinfo/XS/parsetexi/separator.c (handle_close_brace)
	<context brace commands>: Pop the remaining args counter.
	* tp/t/55conditionals.t (inlinefmtifelse_nesting): New test.

2021-02-03  Gavin Smith  <gavinsmith0123@gmail.com>

	"Inline" command nesting

	* tp/Texinfo/ParserNonXS.pm (%default_valid_nestings),
	* tp/Texinfo/XS/parsetexi/parser.c (check_valid_nesting):
	Allow anything inside an inline command like @inlinefmt.
	
	The ccd2cue manual nested @footnote inside of @inlinefmtifelse.

2021-02-03  Gavin Smith  <gavinsmith0123@gmail.com>

	Copiable anchors tweaks
	
	* tp/Texinfo/Convert/HTML.pm
	(_convert_item_command, _convert_def_line_type, %css_map):
	Wrap <a> for copiable anchor in a <span> to avoid it flickering
	when mouse pointer moves over page.
	(_get_copiable_anchor, %css_map) Precede it with a space character
	rather than using CSS to get space before it, as this looks
	slightly better in Lynx.

2021-01-31  Gavin Smith  <gavinsmith0123@gmail.com>

	Rename node to avoid .

	* doc/texinfo.texi (@small..., small): Rename node to "small"
	as periods in the node name are iffy.  Update or remove references to
	this node.
	
	'info texinfo smallexample' gave the error: Cannot find node '@small'

2021-01-31  Gavin Smith  <gavinsmith0123@gmail.com>

	Encoding error message in standard format

	* tp/Texinfo/ParserNonXS.pm (_next_text),
	* tp/Texinfo/XS/parsetexi/input.c (convert_to_utf8): File name
	and line number in error message.

2021-01-31  Gavin Smith  <gavinsmith0123@gmail.com>

	* info/display.c (hl_ref_rendition): Use bold for active link
	rather than no underline.

2021-01-31  Gavin Smith  <gavinsmith0123@gmail.com>

	@set txiindexhyphenignore for parsetexi

	* tp/Texinfo/XS/parsetexi/api.c (build_global_info): Set
	'txiindexhyphenignore' and others on 'info' hash.
	* tp/Texinfo/XS/parsetexi/Parsetexi.pm (get_parser_info):
	Copy settings from 'info' to 'values' hash.
	* tp/Texinfo/XS/parsetexi/macro.c (fetch_value): Remove out
	of date comment.
	* tp/t/09indices.t (transparent_sort_chars): New test.

2021-01-27  Patrice Dumas  <pertusus@free.fr>

	* tp/Makefile.am (dist_init_DATA): install init/highlight_syntax.pm.

2021-01-27  Patrice Dumas  <pertusus@free.fr>

	* tp/init/highlight_syntax.pm (highlight_process): add a postfix
	differing for input and output file to disambiguate files otherwise
	than with extension, in particular for the case of html 
	being highlighted.

2021-01-26  Patrice Dumas  <pertusus@free.fr>

	* Texinfo/Convert/HTML.pm (_convert_preformatted_command):
	no extra class based on argument expansion for @smallexample
	as we would prefer if users did not use that @-command.
	From Gavin.

2021-01-26  Patrice Dumas  <pertusus@free.fr>

	* Texinfo/Convert/HTML.pm (%pre_class_commands,
	_convert_preformatted_command, _convert_indented_command,
	_convert_quotation_command, _convert): do not alias @small*
	commands in _convert() but in formatting functions, such that
	the information is not lost and corresponds to the parsing
	tree.  Alias @small* in %pre_class_commands too.

2021-01-26  Patrice Dumas  <pertusus@free.fr>

	* tp/init/highlight_syntax.pm (_get_highlighted_languages,
	%highlighted_languages_list, _get_language, highlight_process):
	In _get_highlighted_languages() call 'source-highlight --lang-list'
	to obtain the list of highlighted languages and highlight only
	languages that are in that list.

2021-01-26  Patrice Dumas  <pertusus@free.fr>

	* tp/init/highlight_syntax.pm (highlight_process): make sure that
	the text fragment to be highlighted ends with a newline.

2021-01-25  Patrice Dumas  <pertusus@free.fr>

	* Texinfo/Common.pm (add_valid_option), texi2any.pl
	(texinfo_add_valid_option): add Texinfo::Common::add_valid_option() 
	to dynamically add customization options.  Also add, in texi2any.pl,
	Texinfo::Config::texinfo_add_valid_option() as a wrapper around 
	Texinfo::Common::add_valid_option() in the Texinfo::Config
	namespace.
	* tp/init/highlight_examples.pm: rename as 
	tp/init/highlight_syntax.pm.  Fix extraction of highlighted 
	fragments.
	Use dynamically added HIGHLIGHT_SYNTAX_DEFAULT customization option
	to setup a default for the language of @example when not set.

2021-01-25  Patrice Dumas  <pertusus@free.fr>

	* tp/init/highlight_examples.pm: use --out-format=html5 to be more
	in line with the type of HTML produced by texi2any.

2021-01-25  Eli Zaretskii  <eliz@gnu.org>

	* info/pcterm.c (w32_kbd_read): Avoid gratuitous flickering of the
	MS-Windows console if screen-buffer size-change events are sent
	without any change in the screen dimensions.

2021-01-24  Patrice Dumas  <pertusus@free.fr>

	* tp/init/highlight_examples.pm: add an init file that does syntax 
	highlighting for @example with language argument using
	source-highlight.

2021-01-24  Patrice Dumas  <pertusus@free.fr>

	* tp/Texinfo/Convert/HTML.pm (_attribute_class): ignore an empty
	extra classes expansion result string.

2021-01-24  Patrice Dumas  <pertusus@free.fr>

	* tp/Texinfo/Convert/HTML.pm (_attribute_class,
	_convert_preformatted_command): pass extra classes as an array
	instead of a string.
	* tp/Texinfo/Convert/HTML.pm (_attribute_class, _protect_class_name):
	protect spaces in _attribute_class extra_classes.
	* tp/Texinfo/Convert/HTML.pm (_convert_preformatted_command):
	use Texinfo::Convert::NodeNameNormalization::convert to convert
	@example arguments to text.

2021-01-24  Patrice Dumas  <pertusus@free.fr>

	* tp/Texinfo/Convert/TexinfoXML.pm (%commands_formatting),
	util/texinfo.dtd:
	use specific entities for guillemotleft and guillemotright
	to be able to distinguish from guillemetleft and guillemetright
	and be able to come back to the @-command that generated the 
	entity.

2021-01-23  Patrice Dumas  <pertusus@free.fr>

	* tp/Texinfo/Convert/TexinfoXML.pm (%commands_args_elements)
	(_convert), tp/t/xml_tests.t, tests/coverage_macro.texi, 
	util/texinfo.dtd, util/txixml2texi.pl: add support for @example
	multiple arguments in TexinfoXML output.  Update xml @example tests.
	* tp/Texinfo/Convert/HTML.pm (_convert_preformatted_command):
	always initialize $extra_class.
	* configure.ac (TEXINFO_DTD_VERSION): Increase to '6.7dev'.

2021-01-23  Gavin Smith  <gavinsmith0123@gmail.com>

	KOI8 support

	* tp/Texinfo/XS/parsetexi/input.c (set_input_encoding)
	(convert_to_utf8): Support KOI8-R and KOI8-U, as these are
	documented to be supported.

2021-01-23  Gavin Smith  <gavinsmith0123@gmail.com>

	Validate UTF-8 input

	* tp/Texinfo/XS/parsetexi/input.c (convert_to_utf8): Use
	iconv to validate UTF-8 input, in case for example the
	encoding is not declared and the input is actually Latin-1.
	Handle conversion errors by advancing in input stream rather
